package com.sw.activemq.consumer;

import com.sw.service.SnatchMaskService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jms.annotation.JmsListener;
import org.springframework.stereotype.Service;

import javax.jms.JMSException;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.ObjectMessage;
import java.util.Date;
import java.util.Map;

@Service
@Slf4j
public class MessageConsumerService {

	@Autowired
	private SnatchMaskService snatchMaskService;

	@JmsListener(destination="mask")
	public void receiveMessage(Message info) {	// 进行消息接收处理
		if(info instanceof MapMessage){
			MapMessage objectMessage=(MapMessage) info;
			try {
				Integer mid = objectMessage.getInt("mid");
				Integer uid = objectMessage.getInt("uid");
				snatchMaskService.doDecrAndCreateOrder(uid, mid);
			} catch (JMSException e) {
				e.printStackTrace();
			}
		}
	}
}
