package com.sw.activemq.producer.impl;

import com.sw.activemq.producer.IMessageProducerService;
import org.springframework.jms.core.JmsMessagingTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.jms.Queue;
import java.util.Map;

@Service
public class MessageProducerServiceImpl implements IMessageProducerService {
	@Resource
	private JmsMessagingTemplate jmsMessagingTemplate;

	@Resource
	private Queue queue;

	@Override
	public void sendMessage(String message) {
		jmsMessagingTemplate.convertAndSend(this.queue, message);
	}

	@Override
	public void sendMessage(Map<String, Object> message) {
		jmsMessagingTemplate.convertAndSend(this.queue, message);
	}
}
