package com.sw.controller;

import com.sw.service.SnatchMaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Date;

/**
 * @Description 抢口罩入口
 * @Author DingLan
 * @Date 2022/2/18 13:13
 **/
@RestController
@RequestMapping("/mask")
public class SnatchMaskController {

    @Resource
    private RedisTemplate redisTemplate;

    @Autowired
    private SnatchMaskService snatchMaskService;

    @GetMapping()
    private String snatch(Integer uid) {
        if (redisTemplate.opsForSet().isMember("userUids", uid)) {
            if (redisTemplate.opsForSet().isMember("successUserUids", uid)) {
                return "你已经抢到口罩了";
            } else {
                return snatchMaskService.doSnatch(uid);
            }
        } else {
            return "非法输入";
        }
    }

    /**
     * 库存保存redis  订单交给mq稍后异步处理
     *
     * @param uid
     * @param mid
     * @return
     */
    @GetMapping("/{mid}")
    private String snatchMQ(Integer uid, @PathVariable("mid") Integer mid) {

        if (redisTemplate.opsForSet().isMember("userUids", uid)) {
            if (redisTemplate.opsForSet().isMember("successUserUids", uid)) {
                return "你已经抢到口罩了";
            } else {
                Object o = new Object();
                synchronized (o){
                    Boolean flag = snatchMaskService.checkAndDecrRemaining(mid);
                    if (flag) {
                        return snatchMaskService.doSnatchMQ(uid, mid);
                    } else {
                        return "库存不足 抢购失败 ";
                    }
                }

            }
        } else {
            return "非法输入";
        }
    }

    @RequestMapping("/redisDecr")
    public void redisDecr(){

       Long res = redisTemplate.opsForValue().increment("remain",-1);
       System.out.println(res);
    }
}
