package com.sw;

import org.junit.Assert;
import org.junit.Test;
import org.junit.jupiter.api.Order;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description TODO
 * @Author DingLan
 * @Date 2022/2/18 10:29
 **/
@RunWith(SpringRunner.class)
@SpringBootTest
public class RedisTest {
    @Autowired
    private RedisTemplate redisTemplate;

    /**
     * 初始化合法用户uid 到redis
     */
    @Test
    @Order(2)
    public void addSetTest(){
        List<Integer> uids = new ArrayList<>();
        for (int i = 0;i < 1000; i++){
            uids.add( i + 1);
        }
        redisTemplate.opsForSet().add("userUids", uids.toArray());
        Assert.assertEquals(1000l, redisTemplate.opsForSet().size("userUids").longValue());
    }

    @Test
    @Order(1)
    public void clear(){
        Long count = redisTemplate.opsForSet().size("userUids");
        System.out.println(count);
        redisTemplate.opsForSet().pop("userUids", count);

    }

    @Test
    public void  isMember(){
//        System.out.println(redisTemplate.opsForSet().isMember("userUid", "18"));
//        System.out.println(redisTemplate.opsForSet().isMember("userUid", 18));
        System.out.println(redisTemplate.opsForSet().isMember("successUserUids", 18));
    }

    @Test
    public void addMas(){
        redisTemplate.opsForHash().put("usableMasks", "mask-1", 100);
        redisTemplate.opsForHash().put("usableMasks", "mask-2", 100);

//        System.out.printf("res: "  + redisTemplate.opsForHash().get("usableMasks", "mask-1").toString());

    }
    @Test
    public void decr(){
//        Long res = redisTemplate.opsForHash().increment("usableMasks", "mask-1", -5l);
//        System.out.println(res);
        redisTemplate.opsForValue().set("remain", 100);
    }
}
